import { Location, To } from "react-router";
export declare type LeafSegment = Omit<Location, "pathname"> & {
    type: "leaf";
};
export declare type BranchSegment = {
    type: "branch";
    pathnamePart: string;
    key: string;
};
export declare type Segment = LeafSegment | BranchSegment;
export declare type HistoryForPrefix = {
    index: number;
    segments: Segment[];
};
export declare type Prefix = string;
export declare type NestedHistory = {
    segments: {
        [prefix: Prefix]: HistoryForPrefix;
        "/": HistoryForPrefix;
    };
};
export declare const getLocationFromHistory: (history: NestedHistory) => Location;
export declare type GoConfig = {
    onPath?: string;
    direction?: "back" | "forward";
    count?: number;
};
export declare const getHistoryForPrefix: (history: NestedHistory, prefix: string, key?: string) => Location[];
export declare type PrefixIndexes = {
    [prefix: string]: number;
};
export declare const getHistoryWithIndexesForPrefix: (history: NestedHistory, prefix: string, parentPrefixIndexes: PrefixIndexes, key?: string) => {
    location: Location;
    prefixIndexes: PrefixIndexes;
}[];
export declare const applyPrefixIndexesToHistory: (history: NestedHistory, prefixIndexes: PrefixIndexes) => NestedHistory;
export declare const resetPrefix: (history: NestedHistory, prefix: string) => NestedHistory;
export declare const removePrefix: (history: NestedHistory, prefix: string) => NestedHistory;
export declare const pushLocationToHistory: (history: NestedHistory, to: To, replace?: boolean, state?: any) => NestedHistory;
export declare const go: (history: NestedHistory, config?: GoConfig) => {
    handled: boolean;
    history: NestedHistory;
};
export declare const defaultNestedHistory: NestedHistory;
export declare const getInitialHistoryForPath: (pathname: string) => NestedHistory;
