import { ReactElement, ReactNode } from "react";
export declare type TabConfig<AdditionalTabConfig = Record<string, unknown>> = {
    title?: string;
    icon?: (props: {
        active: boolean;
        color: string;
        size: number;
    }) => ReactNode;
} & AdditionalTabConfig;
export declare type TabsConfig<AdditionalTabConfig extends Record<string, unknown>> = {
    [path: string]: TabConfig<AdditionalTabConfig>;
};
export declare type Tabs<AdditionalTabConfig extends Record<string, unknown>> = ({
    tabLink: string;
    active: boolean;
} & TabConfig<AdditionalTabConfig>)[];
export declare type TabNavigatorProps<AdditionalTabConfig extends Record<string, unknown> = Record<string, unknown>> = {
    tabsConfig?: TabsConfig<AdditionalTabConfig>;
    BottomTabsComponent?: (props: {
        tabs: Tabs<AdditionalTabConfig>;
    }) => ReactElement;
};
