import { FC } from "react";
import { Location } from "react-router";
import { GoConfig, NestedHistory, PrefixIndexes } from "../history/nativeHistory";
export declare const useNestedHistoryContext: () => {
    history: NestedHistory;
    go: (config?: GoConfig) => void;
    getHistoryForPrefix: (prefix: string) => Location[];
    removePrefix: (prefix: string) => void;
    resetPrefix: (prefix: string) => void;
    applyPrefixIndexesToHistory: (prefixIndexes: PrefixIndexes) => void;
    getHistoryWithIndexesForPrefix: (prefix: string) => {
        location: Location;
        prefixIndexes: PrefixIndexes;
    }[];
};
declare const NativeRouter: FC<{
    initialHistory?: NestedHistory;
    attachWebURLOn?: string;
}>;
export default NativeRouter;
