/**
 * Creates a route config from a React "children" object, which is usually
 * either a `<Route>` element or an array of them. Used internally by
 * `<Routes>` to create a route config from its children.
 *
 * @see https://reactrouter.com/docs/en/v6/utils/create-routes-from-children
 */
import React from "react";
import { RouteObject } from "react-router";
import { RouteConfig } from "../components/Route";
export declare type RouteObjectWithConfig = RouteObject & {
    additional: RouteConfig;
};
declare function createRoutesFromChildren(children: React.ReactNode): RouteObjectWithConfig[];
export default createRoutesFromChildren;
